Index: trunk/examples/extended/electromagnetic/TestEm14/GNUmakefile
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/GNUmakefile	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/GNUmakefile	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.3 2006/10/24 16:54:16 maire Exp $
+# $Id: GNUmakefile,v 1.4 2008/06/11 22:47:10 maire Exp $
 # --------------------------------------------------------------
 # GNUmakefile for examples module.  Gabriele Cosmo, 06/04/98.
@@ -17,15 +17,5 @@
 #### G4ANALYSIS_USE := true
 
-ifdef G4ANALYSIS_USE
-  CPPFLAGS += -DG4ANALYSIS_USE
-endif
-
 include $(G4INSTALL)/config/architecture.gmk
-
-ifdef G4ANALYSIS_USE
-  # for the aida-config command see the README file
-  CPPFLAGS += `aida-config --include`
-  LOADLIBS += `aida-config --lib`  
-endif
 
 include $(G4INSTALL)/config/binmake.gmk
Index: trunk/examples/extended/electromagnetic/TestEm14/TestEm14.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/TestEm14.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/TestEm14.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: TestEm14.cc,v 1.4 2007/06/23 22:23:20 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/compton.mac
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/compton.mac	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/compton.mac	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: compton.mac,v 1.3 2006/09/06 09:56:06 maire Exp $
+# $Id: compton.mac,v 1.4 2009/09/25 11:43:33 maire Exp $
 #
 # Macro file for "TestEm14.cc"
@@ -12,6 +12,4 @@
 #
 /testem/phys/addPhysics standard
-####/testem/phys/addPhysics livermore
-####/testem/phys/addPhysics penelope
 #
 /run/initialize
@@ -24,6 +22,6 @@
 /gun/energy 300 keV
 #
-/testem/histo/setFileName compton
-/testem/histo/setFileType hbook
+/testem/histo/setFileName testem14
+/testem/histo/setFileType root
 /testem/histo/setHisto 1  100 0. 300. keV	#energy  of primary  
 /testem/histo/setHisto 2  200 -1. +1. none	#costeta of primary
Index: trunk/examples/extended/electromagnetic/TestEm14/include/DetectorConstruction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/DetectorConstruction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/DetectorConstruction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorConstruction.hh,v 1.3 2006/06/29 16:44:56 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/DetectorMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/DetectorMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/DetectorMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.hh,v 1.3 2006/06/29 16:44:58 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/EventAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/EventAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/EventAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventAction.hh,v 1.3 2006/06/29 16:45:00 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/EventActionMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/EventActionMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/EventActionMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.hh,v 1.3 2006/06/29 16:45:02 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/HistoManager.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/HistoManager.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/HistoManager.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: HistoManager.hh,v 1.4 2007/11/13 12:13:32 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/HistoMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/HistoMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/HistoMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: HistoMessenger.hh,v 1.4 2007/11/13 12:13:32 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/PhysListEmLivermore.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/PhysListEmLivermore.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/PhysListEmLivermore.hh	(revision 1230)
@@ -24,7 +24,6 @@
 // ********************************************************************
 //
-//
-// $Id: PhysListEmLivermore.hh,v 1.2 2006/06/29 16:45:10 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysListEmLivermore.hh,v 1.4 2009/11/19 10:36:37 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -42,5 +41,5 @@
 {
   public: 
-    PhysListEmLivermore(const G4String& name = "Livermore");
+    PhysListEmLivermore(const G4String& name = "livermore");
    ~PhysListEmLivermore();
 
Index: trunk/examples/extended/electromagnetic/TestEm14/include/PhysListEmPenelope.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/PhysListEmPenelope.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/PhysListEmPenelope.hh	(revision 1230)
@@ -24,7 +24,6 @@
 // ********************************************************************
 //
-//
-// $Id: PhysListEmPenelope.hh,v 1.2 2006/06/29 16:45:12 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysListEmPenelope.hh,v 1.4 2009/11/19 10:36:37 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -42,5 +41,5 @@
 {
   public: 
-    PhysListEmPenelope(const G4String& name = "Penelope");
+    PhysListEmPenelope(const G4String& name = "penelope");
    ~PhysListEmPenelope();
 
Index: trunk/examples/extended/electromagnetic/TestEm14/include/PhysListEmStandard.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/PhysListEmStandard.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/PhysListEmStandard.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PhysListEmStandard.hh,v 1.3 2006/06/29 16:45:14 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/PhysicsList.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/PhysicsList.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/PhysicsList.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: PhysicsList.hh,v 1.3 2006/06/29 16:45:16 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/PhysicsListMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/PhysicsListMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/PhysicsListMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PhysicsListMessenger.hh,v 1.3 2006/06/29 16:45:18 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/PrimaryGeneratorAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/PrimaryGeneratorAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/PrimaryGeneratorAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorAction.hh,v 1.3 2006/06/29 16:45:20 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/ProcessesCount.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/ProcessesCount.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/ProcessesCount.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: ProcessesCount.hh,v 1.3 2006/06/29 16:45:22 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/RunAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/RunAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/RunAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: RunAction.hh,v 1.4 2006/09/06 09:56:06 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/SteppingAction.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/SteppingAction.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/SteppingAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingAction.hh,v 1.4 2006/09/06 09:56:06 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/SteppingMessenger.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/SteppingMessenger.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/SteppingMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingMessenger.hh,v 1.2 2006/06/29 16:45:29 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/include/SteppingVerbose.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/include/SteppingVerbose.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/include/SteppingVerbose.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingVerbose.hh,v 1.3 2006/06/29 16:45:31 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //   This class manages the verbose outputs in G4SteppingManager. 
Index: trunk/examples/extended/electromagnetic/TestEm14/src/DetectorConstruction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/src/DetectorConstruction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/src/DetectorConstruction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorConstruction.cc,v 1.4 2006/06/29 16:45:33 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/src/DetectorMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/src/DetectorMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/src/DetectorMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.cc,v 1.3 2006/06/29 16:45:35 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/src/EventAction.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/src/EventAction.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/src/EventAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventAction.cc,v 1.3 2006/06/29 16:45:37 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/src/EventActionMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/src/EventActionMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/src/EventActionMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.cc,v 1.3 2006/06/29 16:45:39 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/src/HistoManager.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/src/HistoManager.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/src/HistoManager.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: HistoManager.cc,v 1.5 2007/11/13 12:13:32 maire Exp $
-// GEANT4 tag $Name: geant4-09-01-patch-02 $
+// $Id: HistoManager.cc,v 1.7 2008/09/24 18:53:56 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -54,6 +54,6 @@
  
   fileName[0] = "testem14";
-  fileType    = "hbook";
-  fileOption  = "--noErrors uncompress";  
+  fileType    = "root";
+  fileOption  = "--noErrors export=root uncompress";  
   // histograms
   for (G4int k=0; k<MaxHisto; k++) {
@@ -218,5 +218,5 @@
 void HistoManager::PrintHisto(G4int ih)
 {
- if (ih < MaxHisto) ascii[ih] = true;
+ if (ih < MaxHisto) { ascii[ih] = true; ascii[0] = true; }
  else
     G4cout << "---> warning from HistoManager::PrintHisto() : histo " << ih
@@ -231,4 +231,6 @@
 {
 #ifdef G4ANALYSIS_USE
+ 
+ if (!ascii[0]) return;
  
  G4String name = fileName[0] + ".ascii";
Index: trunk/examples/extended/electromagnetic/TestEm14/src/HistoMessenger.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/src/HistoMessenger.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/src/HistoMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: HistoMessenger.cc,v 1.4 2007/11/13 12:17:07 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/electromagnetic/TestEm14/src/PhysListEmLivermore.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/src/PhysListEmLivermore.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/src/PhysListEmLivermore.cc	(revision 1230)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: PhysListEmLivermore.cc,v 1.2 2006/06/29 16:45:47 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysListEmLivermore.cc,v 1.4 2009/11/19 10:36:37 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -35,14 +35,32 @@
 #include "G4ProcessManager.hh"
 
-#include "G4LowEnergyCompton.hh"
-#include "G4LowEnergyGammaConversion.hh"
-#include "G4LowEnergyPhotoElectric.hh"
-#include "G4LowEnergyRayleigh.hh"
+// gamma
 
-#include "G4LowEnergyIonisation.hh"
-#include "G4LowEnergyBremsstrahlung.hh"
+#include "G4PhotoElectricEffect.hh"
+#include "G4LivermorePhotoElectricModel.hh"
+
+#include "G4ComptonScattering.hh"
+#include "G4LivermoreComptonModel.hh"
+
+#include "G4GammaConversion.hh"
+#include "G4LivermoreGammaConversionModel.hh"
+
+#include "G4RayleighScattering.hh" 
+#include "G4LivermoreRayleighModel.hh"
+
+// e-
+
 #include "G4eIonisation.hh"
+#include "G4LivermoreIonisationModel.hh"
+#include "G4UniversalFluctuation.hh"
+
 #include "G4eBremsstrahlung.hh"
+#include "G4LivermoreBremsstrahlungModel.hh"
+
+// e+
+
 #include "G4eplusAnnihilation.hh"
+
+// mu
 
 #include "G4MuIonisation.hh"
@@ -50,5 +68,9 @@
 #include "G4MuPairProduction.hh"
 
-#include "G4hLowEnergyIonisation.hh"
+// hadrons, ions
+
+#include "G4hIonisation.hh"
+#include "G4ionIonisation.hh"
+
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -67,5 +89,5 @@
 void PhysListEmLivermore::ConstructProcess()
 {
-  // Add LowEn or standard EM Processes
+  // Add standard EM Processes
 
   theParticleIterator->reset();
@@ -74,35 +96,78 @@
     G4ProcessManager* pmanager = particle->GetProcessManager();
     G4String particleName = particle->GetParticleName();
-     
+
+    //Applicability range for Livermore models
+    //for higher energies, the Standard models are used   
+    G4double highEnergyLimit = 1*GeV;
+         
     if (particleName == "gamma") {
       // gamma         
-      pmanager->AddDiscreteProcess(new G4LowEnergyPhotoElectric);
-      pmanager->AddDiscreteProcess(new G4LowEnergyCompton);
-      pmanager->AddDiscreteProcess(new G4LowEnergyGammaConversion);
-      pmanager->AddDiscreteProcess(new G4LowEnergyRayleigh);
+
+      G4PhotoElectricEffect* phot = new G4PhotoElectricEffect();
+      G4LivermorePhotoElectricModel* 
+      photModel = new G4LivermorePhotoElectricModel();
+      photModel->SetHighEnergyLimit(highEnergyLimit);
+      phot->AddEmModel(0, photModel);
+      pmanager->AddDiscreteProcess(phot);
+
+      G4ComptonScattering* compt = new G4ComptonScattering();
+      G4LivermoreComptonModel* 
+      comptModel = new G4LivermoreComptonModel();
+      comptModel->SetHighEnergyLimit(highEnergyLimit);
+      compt->AddEmModel(0, comptModel);
+      pmanager->AddDiscreteProcess(compt);
+
+      G4GammaConversion* conv = new G4GammaConversion();
+      G4LivermoreGammaConversionModel* 
+      convModel = new G4LivermoreGammaConversionModel();
+      convModel->SetHighEnergyLimit(highEnergyLimit);
+      conv->AddEmModel(0, convModel);
+      pmanager->AddDiscreteProcess(conv);
+
+      G4RayleighScattering* rayl = new G4RayleighScattering();
+      G4LivermoreRayleighModel* 
+      raylModel = new G4LivermoreRayleighModel();
+      raylModel->SetHighEnergyLimit(highEnergyLimit);
+      rayl->AddEmModel(0, raylModel);
+      pmanager->AddDiscreteProcess(rayl);
       
     } else if (particleName == "e-") {
       //electron
-      pmanager->AddProcess(new G4LowEnergyIonisation,     -1, 1, 1);
-      pmanager->AddProcess(new G4LowEnergyBremsstrahlung, -1,-1, 2);
-	    
+
+      G4eIonisation* eIoni = new G4eIonisation();
+      G4LivermoreIonisationModel* 
+      eIoniModel = new G4LivermoreIonisationModel();
+      eIoniModel->SetHighEnergyLimit(highEnergyLimit); 
+      eIoni->AddEmModel(0, eIoniModel, new G4UniversalFluctuation() );
+      pmanager->AddProcess(eIoni,                   -1, 1, 1);
+      
+      G4eBremsstrahlung* eBrem = new G4eBremsstrahlung();
+      G4LivermoreBremsstrahlungModel* 
+      eBremModel = new G4LivermoreBremsstrahlungModel();
+      eBremModel->SetHighEnergyLimit(highEnergyLimit);
+      eBrem->AddEmModel(0, eBremModel);
+      pmanager->AddProcess(eBrem,                   -1, 2, 2);
+      	    
     } else if (particleName == "e+") {
       //positron
-      pmanager->AddProcess(new G4eIonisation,        -1, 1, 1);
-      pmanager->AddProcess(new G4eBremsstrahlung,    -1, 2, 2);
-      pmanager->AddProcess(new G4eplusAnnihilation,   0,-1, 3);
+      pmanager->AddProcess(new G4eIonisation,       -1, 1, 1);
+      pmanager->AddProcess(new G4eBremsstrahlung,   -1, 2, 2);
+      pmanager->AddProcess(new G4eplusAnnihilation,  0,-1, 3);
       
     } else if( particleName == "mu+" || 
                particleName == "mu-"    ) {
       //muon  
-      pmanager->AddProcess(new G4MuIonisation,       -1, 1, 1);
-      pmanager->AddProcess(new G4MuBremsstrahlung,   -1, 2, 2);
-      pmanager->AddProcess(new G4MuPairProduction,   -1, 3, 3);       
+      pmanager->AddProcess(new G4MuIonisation,      -1, 1, 1);
+      pmanager->AddProcess(new G4MuBremsstrahlung,  -1, 2, 2);
+      pmanager->AddProcess(new G4MuPairProduction,  -1, 3, 3);       
      
+    } else if( particleName == "alpha" || particleName == "GenericIon" ) { 
+      pmanager->AddProcess(new G4ionIonisation,     -1, 1, 1);
+
     } else if ((!particle->IsShortLived()) &&
 	       (particle->GetPDGCharge() != 0.0) && 
 	       (particle->GetParticleName() != "chargedgeantino")) {
       //all others charged particles except geantino
-      pmanager->AddProcess(new G4hLowEnergyIonisation, -1, 1, 1);
+      pmanager->AddProcess(new G4hIonisation,       -1, 1, 1);
     }
   }
Index: trunk/examples/extended/electromagnetic/TestEm14/src/PhysListEmPenelope.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/src/PhysListEmPenelope.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/src/PhysListEmPenelope.cc	(revision 1230)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: PhysListEmPenelope.cc,v 1.2 2006/06/29 16:45:49 gunter Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysListEmPenelope.cc,v 1.4 2009/11/19 10:36:37 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -35,12 +35,33 @@
 #include "G4ProcessManager.hh"
 
-#include "G4PenelopeCompton.hh"
-#include "G4PenelopeGammaConversion.hh"
-#include "G4PenelopePhotoElectric.hh"
-#include "G4PenelopeRayleigh.hh"
+// gamma
 
-#include "G4PenelopeIonisation.hh"
-#include "G4PenelopeBremsstrahlung.hh"
-#include "G4PenelopeAnnihilation.hh"
+#include "G4PhotoElectricEffect.hh"
+#include "G4PenelopePhotoElectricModel.hh"
+
+#include "G4ComptonScattering.hh"
+#include "G4PenelopeComptonModel.hh"
+
+#include "G4GammaConversion.hh"
+#include "G4PenelopeGammaConversionModel.hh"
+
+#include "G4RayleighScattering.hh" 
+#include "G4PenelopeRayleighModel.hh"
+
+// e-
+
+#include "G4eIonisation.hh"
+#include "G4PenelopeIonisationModel.hh"
+#include "G4UniversalFluctuation.hh"
+
+#include "G4eBremsstrahlung.hh"
+#include "G4PenelopeBremsstrahlungModel.hh"
+
+// e+
+
+#include "G4eplusAnnihilation.hh"
+#include "G4PenelopeAnnihilationModel.hh"
+
+// mu
 
 #include "G4MuIonisation.hh"
@@ -48,6 +69,9 @@
 #include "G4MuPairProduction.hh"
 
+// hadrons, ions
+
 #include "G4hIonisation.hh"
 #include "G4ionIonisation.hh"
+
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -66,5 +90,5 @@
 void PhysListEmPenelope::ConstructProcess()
 {
-  // Add Penelope or standard EM Processes
+  // Add standard EM Processes
 
   theParticleIterator->reset();
@@ -73,38 +97,95 @@
     G4ProcessManager* pmanager = particle->GetProcessManager();
     G4String particleName = particle->GetParticleName();
-     
+
+    //Applicability range for Penelope models
+    //for higher energies, the Standard models are used   
+    G4double highEnergyLimit = 1*GeV;
+         
     if (particleName == "gamma") {
       // gamma         
-      pmanager->AddDiscreteProcess(new G4PenelopePhotoElectric);
-      pmanager->AddDiscreteProcess(new G4PenelopeCompton);
-      pmanager->AddDiscreteProcess(new G4PenelopeGammaConversion);
-      pmanager->AddDiscreteProcess(new G4PenelopeRayleigh);
+
+      G4PhotoElectricEffect* phot = new G4PhotoElectricEffect();
+      G4PenelopePhotoElectricModel* 
+      photModel = new G4PenelopePhotoElectricModel();
+      photModel->SetHighEnergyLimit(highEnergyLimit);
+      phot->AddEmModel(0, photModel);
+      pmanager->AddDiscreteProcess(phot);
+
+      G4ComptonScattering* compt = new G4ComptonScattering();
+      G4PenelopeComptonModel* 
+      comptModel = new G4PenelopeComptonModel();
+      comptModel->SetHighEnergyLimit(highEnergyLimit);
+      compt->AddEmModel(0, comptModel);
+      pmanager->AddDiscreteProcess(compt);
+
+      G4GammaConversion* conv = new G4GammaConversion();
+      G4PenelopeGammaConversionModel* 
+      convModel = new G4PenelopeGammaConversionModel();
+      convModel->SetHighEnergyLimit(highEnergyLimit);
+      conv->AddEmModel(0, convModel);
+      pmanager->AddDiscreteProcess(conv);
+
+      G4RayleighScattering* rayl = new G4RayleighScattering();
+      G4PenelopeRayleighModel* 
+      raylModel = new G4PenelopeRayleighModel();
+      raylModel->SetHighEnergyLimit(highEnergyLimit);
+      rayl->AddEmModel(0, raylModel);
+      pmanager->AddDiscreteProcess(rayl);
       
     } else if (particleName == "e-") {
       //electron
-      pmanager->AddProcess(new G4PenelopeIonisation,     -1, 1, 1);
-      pmanager->AddProcess(new G4PenelopeBremsstrahlung, -1,-1, 2);
-	    
+
+      G4eIonisation* eIoni = new G4eIonisation();
+      G4PenelopeIonisationModel* 
+      eIoniModel = new G4PenelopeIonisationModel();
+      eIoniModel->SetHighEnergyLimit(highEnergyLimit); 
+      eIoni->AddEmModel(0, eIoniModel, new G4UniversalFluctuation() );
+      pmanager->AddProcess(eIoni,                   -1, 1, 1);
+      
+      G4eBremsstrahlung* eBrem = new G4eBremsstrahlung();
+      G4PenelopeBremsstrahlungModel* 
+      eBremModel = new G4PenelopeBremsstrahlungModel();
+      eBremModel->SetHighEnergyLimit(highEnergyLimit);
+      eBrem->AddEmModel(0, eBremModel);
+      pmanager->AddProcess(eBrem,                   -1, 2, 2);
+      	    
     } else if (particleName == "e+") {
       //positron
-      pmanager->AddProcess(new G4PenelopeIonisation,     -1, 1, 1);
-      pmanager->AddProcess(new G4PenelopeBremsstrahlung, -1,-1, 2);      
-      pmanager->AddProcess(new G4PenelopeAnnihilation,    0,-1, 3);
+      G4eIonisation* eIoni = new G4eIonisation();
+      G4PenelopeIonisationModel* 
+      eIoniModel = new G4PenelopeIonisationModel();
+      eIoniModel->SetHighEnergyLimit(highEnergyLimit); 
+      eIoni->AddEmModel(0, eIoniModel, new G4UniversalFluctuation() );
+      pmanager->AddProcess(eIoni,                   -1, 1, 1);
       
+      G4eBremsstrahlung* eBrem = new G4eBremsstrahlung();
+      G4PenelopeBremsstrahlungModel* 
+      eBremModel = new G4PenelopeBremsstrahlungModel();
+      eBremModel->SetHighEnergyLimit(highEnergyLimit);
+      eBrem->AddEmModel(0, eBremModel);
+      pmanager->AddProcess(eBrem,                   -1, 2, 2);      
+
+      G4eplusAnnihilation* eAnni = new G4eplusAnnihilation();
+      G4PenelopeAnnihilationModel* 
+      eAnniModel = new G4PenelopeAnnihilationModel();
+      eAnniModel->SetHighEnergyLimit(highEnergyLimit); 
+      eAnni->AddEmModel(0, eAnniModel);
+      pmanager->AddProcess(eAnni,                    0,-1, 3);
+            
     } else if( particleName == "mu+" || 
                particleName == "mu-"    ) {
       //muon  
-      pmanager->AddProcess(new G4MuIonisation,       -1, 1, 1);
-      pmanager->AddProcess(new G4MuBremsstrahlung,   -1, 2, 2);
-      pmanager->AddProcess(new G4MuPairProduction,   -1, 3, 3);       
+      pmanager->AddProcess(new G4MuIonisation,      -1, 1, 1);
+      pmanager->AddProcess(new G4MuBremsstrahlung,  -1, 2, 2);
+      pmanager->AddProcess(new G4MuPairProduction,  -1, 3, 3);       
      
     } else if( particleName == "alpha" || particleName == "GenericIon" ) { 
-      pmanager->AddProcess(new G4ionIonisation,      -1, 1, 1);
-     
+      pmanager->AddProcess(new G4ionIonisation,     -1, 1, 1);
+
     } else if ((!particle->IsShortLived()) &&
 	       (particle->GetPDGCharge() != 0.0) && 
 	       (particle->GetParticleName() != "chargedgeantino")) {
       //all others charged particles except geantino
-      pmanager->AddProcess(new G4hIonisation,        -1, 1, 1);
+      pmanager->AddProcess(new G4hIonisation,       -1, 1, 1);
     }
   }
Index: trunk/examples/extended/electromagnetic/TestEm14/src/PhysListEmStandard.cc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm14/src/PhysListEmStandard.cc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm14/src/PhysListEmStandard.cc	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: PhysListEmStandard.cc,v 1.4 2006/10/24 16:54:16 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
